#include "SendRecvThread.h"
#include "MySyncObject.h"		// CMySyncObjectg
#include "RingBuff.h"			// CRingBuffg
#include "RecvFileThread.h"		// CRecvFileThreadg
#include "ChatMsgThread.h"		// CChatMsgThreadg

// Mx
#define		SEND_BPS	(1000000.0)	// Mx1Mbps

//----------------------------------------------
// function
//    RXgN^
// parameter
//    ConnectionInfoRec *pConInfo	[in]@\ɕKvȏ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::CSendRecvThread(ConnectionInfoRec *pConInfo)
{
	m_pConInfo = pConInfo;
	m_fIamZombie = FALSE;
	m_pCRingBuffSend = new CRingBuff(SEND_BUFF_SIZE);	// MOobt@̍\z
	m_pCRingBuffRecv = new CRingBuff(RECV_BUFF_SIZE);	// MOobt@̍\z

	m_dwPrevSentTime = 0;								// 񑗐M͂
	m_dwSendInterval = 0;								// 

	m_pCRecvFileThread = new CRecvFileThread(this);		// t@CMXbhɎg悤ɏ
	m_pCRecvFileThread->Begin();

	// `bgbZ[WɎg悤ɏ
	m_pCChatMsgThread = new CChatMsgThread(this);
	m_pCChatMsgThread->Begin();
}

//----------------------------------------------
// function
//    fXgN^
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::~CSendRecvThread()
{
	if (m_pCChatMsgThread != NULL)						// ̃NXjƂɃ`bgbZ[WXbhj
	{
		m_pCChatMsgThread->End();
		m_pCChatMsgThread->WaitForEnd();
	}
	SAFE_DELETE(m_pCChatMsgThread)
	if (m_pCRecvFileThread != NULL)						// ̃NXjƂɃt@CMXbhj
	{
		m_pCRecvFileThread->End();
		m_pCRecvFileThread->WaitForEnd();
	}
	SAFE_DELETE(m_pCRecvFileThread)

	SAFE_DELETE(m_pCRingBuffSend)		// MOobt@̔j
	SAFE_DELETE(m_pCRingBuffRecv)		// MOobt@̔j
}

//----------------------------------------------
// function
//    @\Lq֐
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
UINT CSendRecvThread::DoWork()
{
	BOOL		fRet = TRUE;
	char	    szRecvBuffer[RCVBUFSIZE];	// Mobt@
	int			iRecvSize;
	pollfd		fds[1] = { 0 };
	char		*pcData = NULL;				// Mf[^
	int			iSendSize = 0;				// Mf[^TCY
	DWORD		dwNow;						// M`FbNo邽

	fprintf(stderr, "DoWork()\n");
	fds[0].fd = m_pConInfo->fdClient;
	while (!m_fStopFlag)
	{
		// vIG[̃XbhjƂ͏I
		// IƓYNCAg͐ؒf
		if (KillZombei() == TRUE)
		{
			fRet = FALSE;
			break;
		}

		// Mf[^邩Oobt@𒲂ׂ
		iSendSize = m_pCRingBuffSend->GetReadableSize();
		fds[0].events = POLLIN | POLLRDHUP;					// MƑ葤̐ؒfCxgݒ
		// `FbN̂߂Ɍݎ擾
		dwNow = timeGetTime();
		// M\Mf[^ƂM\
		if ((iSendSize > 0) && (CanSendNow(dwNow) == TRUE))
			fds[0].events |= POLLOUT;						// ݉\ǉ

		poll(fds, 1, 10);
		if (fds[0].revents & POLLRDHUP)			// 葤̐ؒf
		{
			fprintf(stderr, "Disconnected pollrdhup\n");
			fRet = FALSE;
			break;
		}
		if (fds[0].revents & POLLERR)			// G[
		{
			m_pConInfo->pCMySyncObject->Lock();
			DispErrorMsg("Err:DoWork");
			m_pConInfo->pCMySyncObject->UnLock();
			fRet = FALSE;
			break;
		}
		// M
		if (fds[0].revents & POLLIN)			// Mf[^Cxg
		{
			// MOobt@ɋ󂫂ΎM
			// ŎMȂ΁AreventsŎMs
			iRecvSize = min(m_pCRingBuffRecv->GetWriteableSize(), RCVBUFSIZE);
			if (iRecvSize > 0)
			{
				if ((iRecvSize = recv(m_pConInfo->fdClient, szRecvBuffer, iRecvSize, 0)) <= 0)
				{
					m_pConInfo->pCMySyncObject->Lock();
					if (iRecvSize == 0)
						DispErrorMsg("Disconnected recv");
					else
						DispErrorMsg("Err:recv");
					m_pConInfo->pCMySyncObject->UnLock();
					fRet = FALSE;
					break;
				}
				else
				{
					// 擾f[^ɎMOobt@ɏ
					// MOobt@ɏނ̂͂̃XbhȂ̂ŁAׂď߂͂
					m_pCRingBuffRecv->Write((LPBYTE)szRecvBuffer, iRecvSize);
				}
			}
		}
		// MOobt@Ɋi[Ăf[^̉͂s
		// ̃pPbgi[Ă\̂ŁAreventšʂƂ͖֌W
		// ͂s悤ɂ
		if (AnalyzeDataRecv() == -1)
		{
			m_pConInfo->pCMySyncObject->Lock();
			DispErrorMsg("Err:Packet format");
			m_pConInfo->pCMySyncObject->UnLock();
			fRet = FALSE;
			break;
		}
		// M
		if (fds[0].revents & POLLOUT)		// M\Ȃsend{
		{
			// Mf[^̎擾(PATH_MTU菬Ȃ悤Ɏ擾)
			iSendSize = GetSendData(&pcData);
			if (send(m_pConInfo->fdClient, pcData, iSendSize, 0) != iSendSize)
			{
				DispErrorMsg("Err:send");
				fRet = FALSE;
				break;
			}
			SAFE_FREE(pcData)
			// MƎ񑗐M܂ł̎ԂZbg
			m_dwPrevSentTime = dwNow;
			m_dwSendInterval = CalcNextSendInterval(iSendSize);
		}
	}
	m_pConInfo->pCMySyncObject->Lock();
	m_fIamZombie = TRUE;
	m_pConInfo->pCMySyncObject->UnLock();
	SAFE_FREE(pcData)
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		Mf[^̐ݒ
//		MłȂAG[ƂĐؒf̂ǂ
//		͖Ƃ
// parameter
//		char	*pcData	[in]Mf[^
//		int		iSize	[in]f[^
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetSendData(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	// MOobt@ɋ󂫂ȂƂ͏܂Ȃ
	fRet = m_pCRingBuffSend->Write((LPBYTE)pcData, iSize);
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̎擾
// parameter
//		char **ppcData	[in/out]Mf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetSendData(char **ppcData)
{
	int		iSize = 0;

	// Mf[^邩Oobt@̃f[^TCY𒲂ׂ
	if ((iSize = m_pCRingBuffSend->GetReadableSize()) > 0)
	{
		// MTCYPATH_MTU菬Ă(1024+ʃwb_Ȃv)
		iSize = min(iSize, SENDBUFSIZE);
		*ppcData = (char *)calloc(iSize, sizeof(char));
		iSize = m_pCRingBuffSend->Read((LPBYTE)*ppcData, iSize);
	}
	return(iSize);
}

//----------------------------------------------
// function
//		`bgzpf[^̎擾
//		pPbgPʂŎo
//		͂PpPbg
// parameter
//		char **ppcData	[in/out]`bg]pf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetDataForDistributeChat(char **ppcData)
{
	int			iSize = 0;

	if (m_pCChatMsgThread != NULL)
		iSize = m_pCChatMsgThread->GetDataForDistributeChat(ppcData);
	return(iSize);
}


//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CSendRecvThread::IsZombie()
{
	BOOL	fRet;

	m_pConInfo->pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̉
//		MOobt@Ɋi[Ăf[^𒲂ׂ
// parameter
//		Ȃ
// return
//		0:pPbgĂȂ
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
BOOL CSendRecvThread::AnalyzeDataRecv()
{
	int			iRet = 0;
	HeaderRec	Header;
	WORD		wCmd;
	// f[^TCY𒲂ׂ
	int			iSize = m_pCRingBuffRecv->GetReadableSize();

	if (iSize < sizeof(HeaderRec))			// wb_TCYɖȂƂ͉Ȃ
		goto L_END;

	// wb_؂ǂݍ݂
	m_pCRingBuffRecv->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
	// wb_̉
	if (memcmp(Header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING)) != 0)
	{
		iRet = -1;							// ʎqႤ̂ŃG[
		goto L_END;
	}
	wCmd = ntohs(Header.wCommand);
	Locate(1, 10, 1);
	fprintf(stderr, "CMD:%d", wCmd);

	switch (wCmd)
	{
		case CMD_MSG_DATA:
			iRet = RecvMessagePacket(&Header);
			break;
		// t@CMR}h(C->S)
		case CMD_SEND_FILE_START_REQ:
		case CMD_SEND_FILE_ING:
		case CMD_SEND_FILE_END_REQ:
		case CMD_SEND_FILE_ABORT_REQ:
			iRet = RecvFileSendPacket(&Header);
			break;
		default:						// mȂR}h
			iRet = -1;
			break;
	}
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		bZ[WR}h̎M
// parameter
//		HeaderRec *pHeader	[in]ǂ݂wb_
// return
//		0:pPbgĂȂ
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
BOOL CSendRecvThread::RecvMessagePacket(HeaderRec *pHeader)
{
	int			iRet = 0;
	int			iDataSize, iSize, iPacketSize;
	LPBYTE		pbPacket = NULL;

	iDataSize = ntohs(pHeader->wDataLen);
	iPacketSize = iDataSize + sizeof(HeaderRec);

	iSize = m_pCRingBuffRecv->GetReadableSize();
	if (iSize < iPacketSize)
		goto L_END;
	pbPacket = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	// pPbgŜǂ
	m_pCRingBuffRecv->ReadWithoutUpdateHeadPoint(pbPacket, iPacketSize);
	if (m_pCChatMsgThread != NULL)
	{
		// `bgbZ[WXbhɓnǂݍ񂾂Ƃɂ
		if (m_pCChatMsgThread->m_pCRingBuffCmd->Write(pbPacket, iPacketSize) == TRUE)
		{
			m_pCRingBuffRecv->UpdateHeadPoint(iPacketSize);
			iRet = 1;
		}
	}
	else
	{
		// `bgbZ[WXbhȂ΃G[ؒf
		m_pCRingBuffRecv->UpdateHeadPoint(iPacketSize);
		iRet = -1;
	}
	SAFE_FREE(pbPacket);
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMR}h̎M
//		t@CMR}h(C->S)CRecvThreadɓn
// parameter
//		HeaderRec *pHeader	[in]ǂ݂wb_
// return
//		0:pPbgĂȂ, t@CMt
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
int CSendRecvThread::RecvFileSendPacket(HeaderRec *pHeader)
{
	int			iRet = 0;
	int			iDataSize, iSize, iPacketSize;
	LPBYTE		pbPacket = NULL;

	iDataSize = ntohs(pHeader->wDataLen);
	iPacketSize = iDataSize + sizeof(HeaderRec);

	iSize = m_pCRingBuffRecv->GetReadableSize();
	if (iSize < iPacketSize)
		goto L_END;
	pbPacket = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	// pPbgŜǂ
	m_pCRingBuffRecv->ReadWithoutUpdateHeadPoint(pbPacket, iPacketSize);
	if (m_pCRecvFileThread != NULL)
	{
		// t@CMXbhɓnǂݍ񂾂Ƃɂ
		if (m_pCRecvFileThread->m_pCRingBuffCmd->Write(pbPacket, iPacketSize) == TRUE)
		{
			m_pCRingBuffRecv->UpdateHeadPoint(iPacketSize);
			iRet = 1;
		}
	}
	else
	{
		// t@CMXbhȂ΃G[ؒf
		m_pCRingBuffRecv->UpdateHeadPoint(iPacketSize);
		iRet = -1;
	}
	SAFE_FREE(pbPacket);
L_END:
	return(iRet);
}


//----------------------------------------------
// function
//		̑M܂ł̊Ԋu(msec)߂
// parameter
//		int iSentSize [in]MTCY
// return
//		msec
//----------------------------------------------
DWORD CSendRecvThread::CalcNextSendInterval(int iSentSize)
{
	DWORD	dwInterval = 0;
	double	dbBytePerSec = SEND_BPS / 8.0;
	double	dbCountPerSec;

	if (iSentSize == 0)
		goto L_END;
	dbCountPerSec = dbBytePerSec / (double)iSentSize;
	dwInterval = DWORD(1000.0 / dbCountPerSec);

L_END:
	return(dwInterval);
}


//----------------------------------------------
// function
//		M\
// parameter
//		DWORD dwNow		[in]ݎ
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::CanSendNow(DWORD dwNow)
{
	BOOL	fRet = FALSE;

	if (GetdwInterval(dwNow, m_dwPrevSentTime) >= m_dwSendInterval)
		fRet = TRUE;

	return(fRet);
}

//----------------------------------------------
// function
//		̃XbhXbh(vIG[)̎j
//		jƂ͐ؒf̂߂ CSendRecvThreadI
// parameter
//		Ȃ
// return
//		TRUE:vIG[Ŕj/FALSE:vIG[Ȃ
//----------------------------------------------
BOOL CSendRecvThread::KillZombei()
{
	BOOL	fRet = FALSE;

	if (m_pCRecvFileThread != NULL)
	{
		if (m_pCRecvFileThread->IsZombie() == TRUE)
		{
			m_pCRecvFileThread->End();
			m_pCRecvFileThread->WaitForEnd();
			SAFE_DELETE(m_pCRecvFileThread)
			fRet = TRUE;
		}
	}
	if(m_pCChatMsgThread != NULL)
	{
		if (m_pCChatMsgThread->IsZombie() == TRUE)
		{
			m_pCChatMsgThread->End();
			m_pCChatMsgThread->WaitForEnd();
			SAFE_DELETE(m_pCChatMsgThread)
			fRet = TRUE;
		}
	}
	return(fRet);
}
